/* ProcessManager.c generated by valac 0.40.13, the Vala compiler
 * generated from ProcessManager.vala, do not modify */

/* ProcessManager.vala
 *
 * Copyright 2019 Hannes Schulze
 *
 * Simplified version of ProcessManager.vala by stsdc published under
 * the GPL-3.0 license:
 * https://github.com/stsdc/monitor/blob/master/src/Managers/ProcessManager.vala
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <gio/gio.h>
#include <glibtop/cpu.h>
#include <glibtop.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <glibtop/proclist.h>
#include <gobject/gvaluecollector.h>


#define OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER (optimizer_utils_process_manager_get_type ())
#define OPTIMIZER_UTILS_PROCESS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManager))
#define OPTIMIZER_UTILS_PROCESS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManagerClass))
#define OPTIMIZER_UTILS_IS_PROCESS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER))
#define OPTIMIZER_UTILS_IS_PROCESS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER))
#define OPTIMIZER_UTILS_PROCESS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManagerClass))

typedef struct _OptimizerUtilsProcessManager OptimizerUtilsProcessManager;
typedef struct _OptimizerUtilsProcessManagerClass OptimizerUtilsProcessManagerClass;
typedef struct _OptimizerUtilsProcessManagerPrivate OptimizerUtilsProcessManagerPrivate;

#define OPTIMIZER_UTILS_TYPE_PROCESS (optimizer_utils_process_get_type ())
#define OPTIMIZER_UTILS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess))
#define OPTIMIZER_UTILS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))
#define OPTIMIZER_UTILS_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))

typedef struct _OptimizerUtilsProcess OptimizerUtilsProcess;
typedef struct _OptimizerUtilsProcessClass OptimizerUtilsProcessClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _optimizer_utils_process_manager_unref0(var) ((var == NULL) ? NULL : (var = (optimizer_utils_process_manager_unref (var), NULL)))
#define _optimizer_utils_process_unref0(var) ((var == NULL) ? NULL : (var = (optimizer_utils_process_unref (var), NULL)))
typedef struct _OptimizerUtilsProcessManagerUpdateProcessesData OptimizerUtilsProcessManagerUpdateProcessesData;
typedef struct _Block2Data Block2Data;
typedef struct _OptimizerUtilsParamSpecProcessManager OptimizerUtilsParamSpecProcessManager;
enum  {
	OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_ADDED_SIGNAL,
	OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_REMOVED_SIGNAL,
	OPTIMIZER_UTILS_PROCESS_MANAGER_UPDATED_SIGNAL,
	OPTIMIZER_UTILS_PROCESS_MANAGER_NUM_SIGNALS
};
static guint optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_NUM_SIGNALS] = {0};

struct _OptimizerUtilsProcessManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	OptimizerUtilsProcessManagerPrivate * priv;
};

struct _OptimizerUtilsProcessManagerClass {
	GTypeClass parent_class;
	void (*finalize) (OptimizerUtilsProcessManager *self);
};

struct _OptimizerUtilsProcessManagerPrivate {
	gdouble _cpu_load;
	gdouble* _cpu_loads;
	gint _cpu_loads_length1;
	gint __cpu_loads_size_;
	guint64 cpu_last_used;
	guint64 cpu_last_total;
	guint64* cpu_last_useds;
	gint cpu_last_useds_length1;
	gint _cpu_last_useds_size_;
	guint64* cpu_last_totals;
	gint cpu_last_totals_length1;
	gint _cpu_last_totals_size_;
	GeeHashMap* process_list;
	GeeHashSet* kernel_process_blacklist;
};

struct _OptimizerUtilsProcessManagerUpdateProcessesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	OptimizerUtilsProcessManager* self;
	glibtop_cpu cpu_data;
	glibtop_cpu _tmp0_;
	guint64 used;
	glibtop_cpu _tmp1_;
	guint64 _tmp2_;
	glibtop_cpu _tmp3_;
	guint64 _tmp4_;
	glibtop_cpu _tmp5_;
	guint64 _tmp6_;
	guint64 _tmp7_;
	guint64 _tmp8_;
	glibtop_cpu _tmp9_;
	guint64 _tmp10_;
	guint64 _tmp11_;
	glibtop_cpu _tmp12_;
	guint64* _tmp13_;
	gint _tmp13__length1;
	gdouble* _tmp14_;
	gdouble* _tmp15_;
	gint _tmp15__length1;
	guint64* useds;
	glibtop_cpu _tmp16_;
	guint64* _tmp17_;
	gint _tmp17__length1;
	guint64* _tmp18_;
	gint useds_length1;
	gint _useds_size_;
	gint i;
	gboolean _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	glibtop_cpu _tmp22_;
	guint64* _tmp23_;
	gint _tmp23__length1;
	guint64* _tmp24_;
	gint _tmp24__length1;
	gint _tmp25_;
	glibtop_cpu _tmp26_;
	guint64* _tmp27_;
	gint _tmp27__length1;
	gint _tmp28_;
	guint64 _tmp29_;
	glibtop_cpu _tmp30_;
	guint64* _tmp31_;
	gint _tmp31__length1;
	gint _tmp32_;
	guint64 _tmp33_;
	glibtop_cpu _tmp34_;
	guint64* _tmp35_;
	gint _tmp35__length1;
	gint _tmp36_;
	guint64 _tmp37_;
	gint _vala1_i;
	gboolean _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	glibtop_cpu _tmp41_;
	guint64* _tmp42_;
	gint _tmp42__length1;
	gdouble* _tmp43_;
	gint _tmp43__length1;
	gdouble* _tmp44_;
	gint _tmp44__length1;
	gint _tmp45_;
	guint64* _tmp46_;
	gint _tmp46__length1;
	gint _tmp47_;
	guint64 _tmp48_;
	guint64* _tmp49_;
	gint _tmp49__length1;
	gint _tmp50_;
	guint64 _tmp51_;
	glibtop_cpu _tmp52_;
	guint64* _tmp53_;
	gint _tmp53__length1;
	gint _tmp54_;
	guint64 _tmp55_;
	guint64* _tmp56_;
	gint _tmp56__length1;
	gint _tmp57_;
	guint64 _tmp58_;
	GeeHashSet* remove_me;
	GeeHashSet* _tmp59_;
	GeeIterator* _process_it;
	GeeHashMap* _tmp60_;
	GeeCollection* _tmp61_;
	GeeCollection* _tmp62_;
	GeeCollection* _tmp63_;
	GeeIterator* _tmp64_;
	GeeIterator* _tmp65_;
	GeeIterator* _tmp66_;
	OptimizerUtilsProcess* process;
	GeeIterator* _tmp67_;
	gpointer _tmp68_;
	OptimizerUtilsProcess* _tmp69_;
	glibtop_cpu _tmp70_;
	guint64 _tmp71_;
	guint64 _tmp72_;
	GeeHashSet* _tmp73_;
	OptimizerUtilsProcess* _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	GeeIterator* _pid_it;
	GeeHashSet* _tmp77_;
	GeeIterator* _tmp78_;
	GeeIterator* _tmp79_;
	gint pid;
	GeeIterator* _tmp80_;
	gpointer _tmp81_;
	gint _tmp82_;
	uid_t uid;
	glibtop_proclist proclist;
	gint* pids;
	uid_t _tmp83_;
	glibtop_proclist _tmp84_;
	gint* _tmp85_;
	gint pids_length1;
	gint _pids_size_;
	gint _vala2_i;
	gboolean _tmp86_;
	gint _tmp87_;
	gint _tmp88_;
	glibtop_proclist _tmp89_;
	guint64 _tmp90_;
	gint _vala1_pid;
	gint* _tmp91_;
	gint _tmp91__length1;
	gint _tmp92_;
	gint _tmp93_;
	gboolean _tmp94_;
	GeeHashMap* _tmp95_;
	gint _tmp96_;
	GeeHashSet* _tmp97_;
	gint _tmp98_;
	gint _tmp99_;
	OptimizerUtilsProcess* _tmp100_;
	OptimizerUtilsProcess* _tmp101_;
	guint64 _tmp102_;
	glibtop_cpu _tmp103_;
	guint64 _tmp104_;
	guint64* _tmp105_;
	gint _tmp105__length1;
	guint64* _tmp106_;
	gint _tmp106__length1;
	glibtop_cpu _tmp107_;
	guint64* _tmp108_;
	gint _tmp108__length1;
	guint64* _tmp109_;
	gint _tmp109__length1;
};

struct _Block2Data {
	int _ref_count_;
	OptimizerUtilsProcessManager* self;
	OptimizerUtilsProcess* process;
};

struct _OptimizerUtilsParamSpecProcessManager {
	GParamSpec parent_instance;
};


static gpointer optimizer_utils_process_manager_parent_class = NULL;
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_instance;
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_instance = NULL;

gpointer optimizer_utils_process_manager_ref (gpointer instance);
void optimizer_utils_process_manager_unref (gpointer instance);
GParamSpec* optimizer_utils_param_spec_process_manager (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
void optimizer_utils_value_set_process_manager (GValue* value,
                                                gpointer v_object);
void optimizer_utils_value_take_process_manager (GValue* value,
                                                 gpointer v_object);
gpointer optimizer_utils_value_get_process_manager (const GValue* value);
GType optimizer_utils_process_manager_get_type (void) G_GNUC_CONST;
gpointer optimizer_utils_process_ref (gpointer instance);
void optimizer_utils_process_unref (gpointer instance);
GParamSpec* optimizer_utils_param_spec_process (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void optimizer_utils_value_set_process (GValue* value,
                                        gpointer v_object);
void optimizer_utils_value_take_process (GValue* value,
                                         gpointer v_object);
gpointer optimizer_utils_value_get_process (const GValue* value);
GType optimizer_utils_process_get_type (void) G_GNUC_CONST;
#define OPTIMIZER_UTILS_PROCESS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManagerPrivate))
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_new (void);
static OptimizerUtilsProcessManager* optimizer_utils_process_manager_construct (GType object_type);
static void optimizer_utils_process_manager_update_processes (OptimizerUtilsProcessManager* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void optimizer_utils_process_manager_update_processes_finish (OptimizerUtilsProcessManager* self,
                                                              GAsyncResult* _res_);
static gboolean optimizer_utils_process_manager_handle_timeout (OptimizerUtilsProcessManager* self);
static gboolean _optimizer_utils_process_manager_handle_timeout_gsource_func (gpointer self);
OptimizerUtilsProcess* optimizer_utils_process_manager_get_process (OptimizerUtilsProcessManager* self,
                                                                    gint pid);
static OptimizerUtilsProcess* optimizer_utils_process_manager_add_process (OptimizerUtilsProcessManager* self,
                                                                    gint pid);
GeeMap* optimizer_utils_process_manager_get_process_list (OptimizerUtilsProcessManager* self);
static void optimizer_utils_process_manager_update_processes_data_free (gpointer _data);
static gboolean optimizer_utils_process_manager_update_processes_co (OptimizerUtilsProcessManagerUpdateProcessesData* _data_);
static void optimizer_utils_process_manager_set_cpu_load (OptimizerUtilsProcessManager* self,
                                                   gdouble value);
static void optimizer_utils_process_manager_set_cpu_loads (OptimizerUtilsProcessManager* self,
                                                    gdouble* value,
                                                    int value_length1);
gdouble* optimizer_utils_process_manager_get_cpu_loads (OptimizerUtilsProcessManager* self,
                                                        int* result_length1);
gboolean optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                         guint64 cpu_total,
                                         guint64 cpu_last_total);
gint optimizer_utils_process_get_pid (OptimizerUtilsProcess* self);
static void optimizer_utils_process_manager_remove_process (OptimizerUtilsProcessManager* self,
                                                     gint pid);
static guint64* _vala_array_dup3 (guint64* self,
                           int length);
static guint64* _vala_array_dup4 (guint64* self,
                           int length);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
OptimizerUtilsProcess* optimizer_utils_process_new (gint _pid);
OptimizerUtilsProcess* optimizer_utils_process_construct (GType object_type,
                                                          gint _pid);
gboolean optimizer_utils_process_get_exists (OptimizerUtilsProcess* self);
gint optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self);
static gboolean ____lambda17_ (Block2Data* _data2_);
static gboolean _____lambda17__gsource_func (gpointer self);
OptimizerUtilsProcessManager* optimizer_utils_process_manager_get_instance (void);
gdouble optimizer_utils_process_manager_get_cpu_load (OptimizerUtilsProcessManager* self);
static gdouble* _vala_array_dup5 (gdouble* self,
                           int length);
static void g_cclosure_user_marshal_VOID__OPTIMIZER_UTILS_PROCESS (GClosure * closure,
                                                            GValue * return_value,
                                                            guint n_param_values,
                                                            const GValue * param_values,
                                                            gpointer invocation_hint,
                                                            gpointer marshal_data);
static void optimizer_utils_process_manager_finalize (OptimizerUtilsProcessManager * obj);
static gint _vala_array_length (gpointer array);


/**
         * Constructs a new {@code ProcessManager} object
         */
static gboolean
_optimizer_utils_process_manager_handle_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = optimizer_utils_process_manager_handle_timeout ((OptimizerUtilsProcessManager*) self);
	return result;
}


static OptimizerUtilsProcessManager*
optimizer_utils_process_manager_construct (GType object_type)
{
	OptimizerUtilsProcessManager* self = NULL;
	GeeHashMap* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (OptimizerUtilsProcessManager*) g_type_create_instance (object_type);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, OPTIMIZER_UTILS_TYPE_PROCESS, (GBoxedCopyFunc) optimizer_utils_process_ref, (GDestroyNotify) optimizer_utils_process_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->process_list);
	self->priv->process_list = _tmp0_;
	_tmp1_ = gee_hash_set_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->kernel_process_blacklist);
	self->priv->kernel_process_blacklist = _tmp1_;
	optimizer_utils_process_manager_update_processes (self, NULL, NULL);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 2000, _optimizer_utils_process_manager_handle_timeout_gsource_func, optimizer_utils_process_manager_ref (self), optimizer_utils_process_manager_unref);
	return self;
}


static OptimizerUtilsProcessManager*
optimizer_utils_process_manager_new (void)
{
	return optimizer_utils_process_manager_construct (OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER);
}


/**
         * Gets a process by its pid, making sure that it's updated.
         */
OptimizerUtilsProcess*
optimizer_utils_process_manager_get_process (OptimizerUtilsProcessManager* self,
                                             gint pid)
{
	OptimizerUtilsProcess* result = NULL;
	GeeHashSet* _tmp0_;
	GeeHashMap* _tmp1_;
	OptimizerUtilsProcess* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->kernel_process_blacklist;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((gintptr) pid))) {
		result = NULL;
		return result;
	}
	_tmp1_ = self->priv->process_list;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) pid))) {
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		_tmp2_ = self->priv->process_list;
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) pid));
		result = (OptimizerUtilsProcess*) _tmp3_;
		return result;
	}
	_tmp4_ = optimizer_utils_process_manager_add_process (self, pid);
	result = _tmp4_;
	return result;
}


/**
         * Gets a read only map of the processes currently cached
         */
GeeMap*
optimizer_utils_process_manager_get_process_list (OptimizerUtilsProcessManager* self)
{
	GeeMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->process_list;
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


/**
         * Handle updating the process list
         */
static gboolean
optimizer_utils_process_manager_handle_timeout (OptimizerUtilsProcessManager* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	optimizer_utils_process_manager_update_processes (self, NULL, NULL);
	result = TRUE;
	return result;
}


static void
optimizer_utils_process_manager_update_processes_data_free (gpointer _data)
{
	OptimizerUtilsProcessManagerUpdateProcessesData* _data_;
	_data_ = _data;
	_optimizer_utils_process_manager_unref0 (_data_->self);
	g_slice_free (OptimizerUtilsProcessManagerUpdateProcessesData, _data_);
}


static gpointer
_optimizer_utils_process_manager_ref0 (gpointer self)
{
	return self ? optimizer_utils_process_manager_ref (self) : NULL;
}


static void
optimizer_utils_process_manager_update_processes (OptimizerUtilsProcessManager* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	OptimizerUtilsProcessManagerUpdateProcessesData* _data_;
	OptimizerUtilsProcessManager* _tmp0_;
	_data_ = g_slice_new0 (OptimizerUtilsProcessManagerUpdateProcessesData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, optimizer_utils_process_manager_update_processes_data_free);
	_tmp0_ = _optimizer_utils_process_manager_ref0 (self);
	_data_->self = _tmp0_;
	optimizer_utils_process_manager_update_processes_co (_data_);
}


static void
optimizer_utils_process_manager_update_processes_finish (OptimizerUtilsProcessManager* self,
                                                         GAsyncResult* _res_)
{
	OptimizerUtilsProcessManagerUpdateProcessesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


/**
         * Gets all new process and adds them
         */
static guint64*
_vala_array_dup3 (guint64* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint64));
}


static guint64*
_vala_array_dup4 (guint64* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint64));
}


static gboolean
optimizer_utils_process_manager_update_processes_co (OptimizerUtilsProcessManagerUpdateProcessesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	memset (&_data_->_tmp0_, 0, sizeof (glibtop_cpu));
	glibtop_get_cpu (&_data_->_tmp0_);
	_data_->cpu_data = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->cpu_data;
	_data_->_tmp2_ = _data_->_tmp1_.user;
	_data_->_tmp3_ = _data_->cpu_data;
	_data_->_tmp4_ = _data_->_tmp3_.nice;
	_data_->_tmp5_ = _data_->cpu_data;
	_data_->_tmp6_ = _data_->_tmp5_.sys;
	_data_->used = (_data_->_tmp2_ + _data_->_tmp4_) + _data_->_tmp6_;
	_data_->_tmp7_ = _data_->used;
	_data_->_tmp8_ = _data_->self->priv->cpu_last_used;
	_data_->_tmp9_ = _data_->cpu_data;
	_data_->_tmp10_ = _data_->_tmp9_.total;
	_data_->_tmp11_ = _data_->self->priv->cpu_last_total;
	optimizer_utils_process_manager_set_cpu_load (_data_->self, ((gdouble) (_data_->_tmp7_ - _data_->_tmp8_)) / (_data_->_tmp10_ - _data_->_tmp11_));
	_data_->_tmp12_ = _data_->cpu_data;
	_data_->_tmp13_ = _data_->_tmp12_.xcpu_user;
	_data_->_tmp13__length1 = _vala_array_length (_data_->_tmp12_.xcpu_user);
	_data_->_tmp14_ = g_new0 (gdouble, _data_->_tmp13__length1);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp15__length1 = _data_->_tmp13__length1;
	optimizer_utils_process_manager_set_cpu_loads (_data_->self, _data_->_tmp15_, _data_->_tmp13__length1);
	_data_->_tmp15_ = (g_free (_data_->_tmp15_), NULL);
	_data_->_tmp16_ = _data_->cpu_data;
	_data_->_tmp17_ = _data_->_tmp16_.xcpu_user;
	_data_->_tmp17__length1 = _vala_array_length (_data_->_tmp16_.xcpu_user);
	_data_->_tmp18_ = g_new0 (guint64, _data_->_tmp17__length1);
	_data_->useds = _data_->_tmp18_;
	_data_->useds_length1 = _data_->_tmp17__length1;
	_data_->_useds_size_ = _data_->useds_length1;
	{
		_data_->i = 0;
		{
			_data_->_tmp19_ = TRUE;
			while (TRUE) {
				if (!_data_->_tmp19_) {
					_data_->_tmp20_ = _data_->i;
					_data_->i = _data_->_tmp20_ + 1;
				}
				_data_->_tmp19_ = FALSE;
				_data_->_tmp21_ = _data_->i;
				_data_->_tmp22_ = _data_->cpu_data;
				_data_->_tmp23_ = _data_->_tmp22_.xcpu_user;
				_data_->_tmp23__length1 = _vala_array_length (_data_->_tmp22_.xcpu_user);
				if (!(_data_->_tmp21_ < _data_->_tmp23__length1)) {
					break;
				}
				_data_->_tmp24_ = _data_->useds;
				_data_->_tmp24__length1 = _data_->useds_length1;
				_data_->_tmp25_ = _data_->i;
				_data_->_tmp26_ = _data_->cpu_data;
				_data_->_tmp27_ = _data_->_tmp26_.xcpu_user;
				_data_->_tmp27__length1 = _vala_array_length (_data_->_tmp26_.xcpu_user);
				_data_->_tmp28_ = _data_->i;
				_data_->_tmp29_ = _data_->_tmp27_[_data_->_tmp28_];
				_data_->_tmp30_ = _data_->cpu_data;
				_data_->_tmp31_ = _data_->_tmp30_.xcpu_nice;
				_data_->_tmp31__length1 = _vala_array_length (_data_->_tmp30_.xcpu_nice);
				_data_->_tmp32_ = _data_->i;
				_data_->_tmp33_ = _data_->_tmp31_[_data_->_tmp32_];
				_data_->_tmp34_ = _data_->cpu_data;
				_data_->_tmp35_ = _data_->_tmp34_.xcpu_sys;
				_data_->_tmp35__length1 = _vala_array_length (_data_->_tmp34_.xcpu_sys);
				_data_->_tmp36_ = _data_->i;
				_data_->_tmp37_ = _data_->_tmp35_[_data_->_tmp36_];
				_data_->_tmp24_[_data_->_tmp25_] = (_data_->_tmp29_ + _data_->_tmp33_) + _data_->_tmp37_;
			}
		}
	}
	{
		_data_->_vala1_i = 0;
		{
			_data_->_tmp38_ = TRUE;
			while (TRUE) {
				if (!_data_->_tmp38_) {
					_data_->_tmp39_ = _data_->_vala1_i;
					_data_->_vala1_i = _data_->_tmp39_ + 1;
				}
				_data_->_tmp38_ = FALSE;
				_data_->_tmp40_ = _data_->_vala1_i;
				_data_->_tmp41_ = _data_->cpu_data;
				_data_->_tmp42_ = _data_->_tmp41_.xcpu_user;
				_data_->_tmp42__length1 = _vala_array_length (_data_->_tmp41_.xcpu_user);
				if (!(_data_->_tmp40_ < _data_->_tmp42__length1)) {
					break;
				}
				_data_->_tmp43_ = optimizer_utils_process_manager_get_cpu_loads (_data_->self, &_data_->_tmp43__length1);
				_data_->_tmp44_ = _data_->_tmp43_;
				_data_->_tmp44__length1 = _data_->_tmp43__length1;
				_data_->_tmp45_ = _data_->_vala1_i;
				_data_->_tmp46_ = _data_->useds;
				_data_->_tmp46__length1 = _data_->useds_length1;
				_data_->_tmp47_ = _data_->_vala1_i;
				_data_->_tmp48_ = _data_->_tmp46_[_data_->_tmp47_];
				_data_->_tmp49_ = _data_->self->priv->cpu_last_useds;
				_data_->_tmp49__length1 = _data_->self->priv->cpu_last_useds_length1;
				_data_->_tmp50_ = _data_->_vala1_i;
				_data_->_tmp51_ = _data_->_tmp49_[_data_->_tmp50_];
				_data_->_tmp52_ = _data_->cpu_data;
				_data_->_tmp53_ = _data_->_tmp52_.xcpu_total;
				_data_->_tmp53__length1 = _vala_array_length (_data_->_tmp52_.xcpu_total);
				_data_->_tmp54_ = _data_->_vala1_i;
				_data_->_tmp55_ = _data_->_tmp53_[_data_->_tmp54_];
				_data_->_tmp56_ = _data_->self->priv->cpu_last_totals;
				_data_->_tmp56__length1 = _data_->self->priv->cpu_last_totals_length1;
				_data_->_tmp57_ = _data_->_vala1_i;
				_data_->_tmp58_ = _data_->_tmp56_[_data_->_tmp57_];
				_data_->_tmp44_[_data_->_tmp45_] = ((gdouble) (_data_->_tmp48_ - _data_->_tmp51_)) / (_data_->_tmp55_ - _data_->_tmp58_);
			}
		}
	}
	_data_->_tmp59_ = gee_hash_set_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_data_->remove_me = _data_->_tmp59_;
	{
		_data_->_tmp60_ = _data_->self->priv->process_list;
		_data_->_tmp61_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp60_);
		_data_->_tmp62_ = _data_->_tmp61_;
		_data_->_tmp63_ = _data_->_tmp62_;
		_data_->_tmp64_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp63_);
		_data_->_tmp65_ = _data_->_tmp64_;
		_g_object_unref0 (_data_->_tmp63_);
		_data_->_process_it = _data_->_tmp65_;
		while (TRUE) {
			_data_->_tmp66_ = _data_->_process_it;
			if (!gee_iterator_next (_data_->_tmp66_)) {
				break;
			}
			_data_->_tmp67_ = _data_->_process_it;
			_data_->_tmp68_ = gee_iterator_get (_data_->_tmp67_);
			_data_->process = (OptimizerUtilsProcess*) _data_->_tmp68_;
			_data_->_tmp69_ = _data_->process;
			_data_->_tmp70_ = _data_->cpu_data;
			_data_->_tmp71_ = _data_->_tmp70_.total;
			_data_->_tmp72_ = _data_->self->priv->cpu_last_total;
			if (!optimizer_utils_process_update (_data_->_tmp69_, _data_->_tmp71_, _data_->_tmp72_)) {
				_data_->_tmp73_ = _data_->remove_me;
				_data_->_tmp74_ = _data_->process;
				_data_->_tmp75_ = optimizer_utils_process_get_pid (_data_->_tmp74_);
				_data_->_tmp76_ = _data_->_tmp75_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp73_, (gpointer) ((gintptr) _data_->_tmp76_));
			}
			_optimizer_utils_process_unref0 (_data_->process);
		}
		_g_object_unref0 (_data_->_process_it);
	}
	{
		_data_->_tmp77_ = _data_->remove_me;
		_data_->_tmp78_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp77_);
		_data_->_pid_it = _data_->_tmp78_;
		while (TRUE) {
			_data_->_tmp79_ = _data_->_pid_it;
			if (!gee_iterator_next (_data_->_tmp79_)) {
				break;
			}
			_data_->_tmp80_ = _data_->_pid_it;
			_data_->_tmp81_ = gee_iterator_get (_data_->_tmp80_);
			_data_->pid = (gint) ((gintptr) _data_->_tmp81_);
			_data_->_tmp82_ = _data_->pid;
			optimizer_utils_process_manager_remove_process (_data_->self, _data_->_tmp82_);
		}
		_g_object_unref0 (_data_->_pid_it);
	}
	_data_->uid = getuid ();
	_data_->_tmp83_ = _data_->uid;
	memset (&_data_->_tmp84_, 0, sizeof (glibtop_proclist));
	_data_->_tmp85_ = glibtop_get_proclist (&_data_->_tmp84_, (gint64) GLIBTOP_KERN_PROC_UID, (gint64) _data_->_tmp83_);
	_data_->proclist = _data_->_tmp84_;
	_data_->pids = _data_->_tmp85_;
	_data_->pids_length1 = -1;
	_data_->_pids_size_ = _data_->pids_length1;
	{
		_data_->_vala2_i = 0;
		{
			_data_->_tmp86_ = TRUE;
			while (TRUE) {
				if (!_data_->_tmp86_) {
					_data_->_tmp87_ = _data_->_vala2_i;
					_data_->_vala2_i = _data_->_tmp87_ + 1;
				}
				_data_->_tmp86_ = FALSE;
				_data_->_tmp88_ = _data_->_vala2_i;
				_data_->_tmp89_ = _data_->proclist;
				_data_->_tmp90_ = _data_->_tmp89_.number;
				if (!(((guint64) _data_->_tmp88_) < _data_->_tmp90_)) {
					break;
				}
				_data_->_tmp91_ = _data_->pids;
				_data_->_tmp91__length1 = _data_->pids_length1;
				_data_->_tmp92_ = _data_->_vala2_i;
				_data_->_tmp93_ = _data_->_tmp91_[_data_->_tmp92_];
				_data_->_vala1_pid = _data_->_tmp93_;
				_data_->_tmp95_ = _data_->self->priv->process_list;
				_data_->_tmp96_ = _data_->_vala1_pid;
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _data_->_tmp95_, (gpointer) ((gintptr) _data_->_tmp96_))) {
					_data_->_tmp97_ = _data_->self->priv->kernel_process_blacklist;
					_data_->_tmp98_ = _data_->_vala1_pid;
					_data_->_tmp94_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp97_, (gpointer) ((gintptr) _data_->_tmp98_));
				} else {
					_data_->_tmp94_ = FALSE;
				}
				if (_data_->_tmp94_) {
					_data_->_tmp99_ = _data_->_vala1_pid;
					_data_->_tmp100_ = optimizer_utils_process_manager_add_process (_data_->self, _data_->_tmp99_);
					_data_->_tmp101_ = _data_->_tmp100_;
					_optimizer_utils_process_unref0 (_data_->_tmp101_);
				}
			}
		}
	}
	_data_->_tmp102_ = _data_->used;
	_data_->self->priv->cpu_last_used = _data_->_tmp102_;
	_data_->_tmp103_ = _data_->cpu_data;
	_data_->_tmp104_ = _data_->_tmp103_.total;
	_data_->self->priv->cpu_last_total = _data_->_tmp104_;
	_data_->_tmp105_ = _data_->useds;
	_data_->_tmp105__length1 = _data_->useds_length1;
	_data_->_tmp106_ = (_data_->_tmp105_ != NULL) ? _vala_array_dup3 (_data_->_tmp105_, _data_->_tmp105__length1) : ((gpointer) _data_->_tmp105_);
	_data_->_tmp106__length1 = _data_->_tmp105__length1;
	_data_->self->priv->cpu_last_useds = (g_free (_data_->self->priv->cpu_last_useds), NULL);
	_data_->self->priv->cpu_last_useds = _data_->_tmp106_;
	_data_->self->priv->cpu_last_useds_length1 = _data_->_tmp106__length1;
	_data_->self->priv->_cpu_last_useds_size_ = _data_->self->priv->cpu_last_useds_length1;
	_data_->_tmp107_ = _data_->cpu_data;
	_data_->_tmp108_ = _data_->_tmp107_.xcpu_total;
	_data_->_tmp108__length1 = _vala_array_length (_data_->_tmp107_.xcpu_total);
	_data_->_tmp109_ = (_data_->_tmp108_ != NULL) ? _vala_array_dup4 (_data_->_tmp108_, _data_->_tmp108__length1) : ((gpointer) _data_->_tmp108_);
	_data_->_tmp109__length1 = _data_->_tmp108__length1;
	_data_->self->priv->cpu_last_totals = (g_free (_data_->self->priv->cpu_last_totals), NULL);
	_data_->self->priv->cpu_last_totals = _data_->_tmp109_;
	_data_->self->priv->cpu_last_totals_length1 = _data_->_tmp109__length1;
	_data_->self->priv->_cpu_last_totals_size_ = _data_->self->priv->cpu_last_totals_length1;
	g_signal_emit (_data_->self, optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_UPDATED_SIGNAL], 0);
	_data_->pids = (g_free (_data_->pids), NULL);
	_g_object_unref0 (_data_->remove_me);
	_data_->useds = (g_free (_data_->useds), NULL);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
         * Parses a pid and adds a Process to our process_list or to the kernel_blacklist
         *
         * returns the created process
         */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		OptimizerUtilsProcessManager* self;
		self = _data2_->self;
		_optimizer_utils_process_unref0 (_data2_->process);
		_optimizer_utils_process_manager_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean
____lambda17_ (Block2Data* _data2_)
{
	OptimizerUtilsProcessManager* self;
	gboolean result = FALSE;
	OptimizerUtilsProcess* _tmp0_;
	self = _data2_->self;
	_tmp0_ = _data2_->process;
	g_signal_emit (self, optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_ADDED_SIGNAL], 0, _tmp0_);
	result = FALSE;
	return result;
}


static gboolean
_____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda17_ (self);
	return result;
}


static gpointer
_optimizer_utils_process_ref0 (gpointer self)
{
	return self ? optimizer_utils_process_ref (self) : NULL;
}


static OptimizerUtilsProcess*
optimizer_utils_process_manager_add_process (OptimizerUtilsProcessManager* self,
                                             gint pid)
{
	OptimizerUtilsProcess* result = NULL;
	Block2Data* _data2_;
	OptimizerUtilsProcess* _tmp0_;
	OptimizerUtilsProcess* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = optimizer_utils_process_manager_ref (self);
	_tmp0_ = optimizer_utils_process_new (pid);
	_data2_->process = _tmp0_;
	_tmp1_ = _data2_->process;
	_tmp2_ = optimizer_utils_process_get_exists (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		OptimizerUtilsProcess* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp4_ = _data2_->process;
		_tmp5_ = optimizer_utils_process_get_pgrp (_tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_ != 0) {
			GeeHashMap* _tmp7_;
			OptimizerUtilsProcess* _tmp8_;
			OptimizerUtilsProcess* _tmp9_;
			OptimizerUtilsProcess* _tmp10_;
			_tmp7_ = self->priv->process_list;
			_tmp8_ = _data2_->process;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) pid), _tmp8_);
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda17__gsource_func, block2_data_ref (_data2_), block2_data_unref);
			_tmp9_ = _data2_->process;
			_tmp10_ = _optimizer_utils_process_ref0 (_tmp9_);
			result = _tmp10_;
			block2_data_unref (_data2_);
			_data2_ = NULL;
			return result;
		} else {
			GeeHashSet* _tmp11_;
			_tmp11_ = self->priv->kernel_process_blacklist;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, (gpointer) ((gintptr) pid));
		}
	}
	result = NULL;
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


/**
         * Remove the process from all lists and broadcast the process_removed signal if removed.
         */
static void
optimizer_utils_process_manager_remove_process (OptimizerUtilsProcessManager* self,
                                                gint pid)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->process_list;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) pid))) {
		GeeHashMap* _tmp1_;
		_tmp1_ = self->priv->process_list;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) pid), NULL);
		g_signal_emit (self, optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_REMOVED_SIGNAL], 0, pid);
	} else {
		GeeHashSet* _tmp2_;
		_tmp2_ = self->priv->kernel_process_blacklist;
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, (gpointer) ((gintptr) pid))) {
			GeeHashSet* _tmp3_;
			_tmp3_ = self->priv->kernel_process_blacklist;
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, (gpointer) ((gintptr) pid));
		}
	}
}


/**
         * Returns a single instance of this class.
         *
         * @return {@code ProcessManager}
         */
OptimizerUtilsProcessManager*
optimizer_utils_process_manager_get_instance (void)
{
	OptimizerUtilsProcessManager* result = NULL;
	OptimizerUtilsProcessManager* _tmp0_;
	OptimizerUtilsProcessManager* _tmp2_;
	_tmp0_ = optimizer_utils_process_manager_instance;
	if (_tmp0_ == NULL) {
		OptimizerUtilsProcessManager* _tmp1_;
		_tmp1_ = optimizer_utils_process_manager_new ();
		_optimizer_utils_process_manager_unref0 (optimizer_utils_process_manager_instance);
		optimizer_utils_process_manager_instance = _tmp1_;
	}
	_tmp2_ = optimizer_utils_process_manager_instance;
	result = _tmp2_;
	return result;
}


gdouble
optimizer_utils_process_manager_get_cpu_load (OptimizerUtilsProcessManager* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_cpu_load;
	result = _tmp0_;
	return result;
}


static void
optimizer_utils_process_manager_set_cpu_load (OptimizerUtilsProcessManager* self,
                                              gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_cpu_load = value;
}


gdouble*
optimizer_utils_process_manager_get_cpu_loads (OptimizerUtilsProcessManager* self,
                                               int* result_length1)
{
	gdouble* result;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cpu_loads;
	_tmp0__length1 = self->priv->_cpu_loads_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static gdouble*
_vala_array_dup5 (gdouble* self,
                  int length)
{
	return g_memdup (self, length * sizeof (gdouble));
}


static void
optimizer_utils_process_manager_set_cpu_loads (OptimizerUtilsProcessManager* self,
                                               gdouble* value,
                                               int value_length1)
{
	gdouble* _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : ((gpointer) value);
	_tmp0__length1 = value_length1;
	self->priv->_cpu_loads = (g_free (self->priv->_cpu_loads), NULL);
	self->priv->_cpu_loads = _tmp0_;
	self->priv->_cpu_loads_length1 = _tmp0__length1;
	self->priv->__cpu_loads_size_ = self->priv->_cpu_loads_length1;
}


static void
g_cclosure_user_marshal_VOID__OPTIMIZER_UTILS_PROCESS (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OPTIMIZER_UTILS_PROCESS) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__OPTIMIZER_UTILS_PROCESS callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OPTIMIZER_UTILS_PROCESS) (marshal_data ? marshal_data : cc->callback);
	callback (data1, optimizer_utils_value_get_process (param_values + 1), data2);
}


static void
optimizer_utils_value_process_manager_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
optimizer_utils_value_process_manager_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		optimizer_utils_process_manager_unref (value->data[0].v_pointer);
	}
}


static void
optimizer_utils_value_process_manager_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = optimizer_utils_process_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
optimizer_utils_value_process_manager_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
optimizer_utils_value_process_manager_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		OptimizerUtilsProcessManager * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = optimizer_utils_process_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
optimizer_utils_value_process_manager_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	OptimizerUtilsProcessManager ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = optimizer_utils_process_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec*
optimizer_utils_param_spec_process_manager (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	OptimizerUtilsParamSpecProcessManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer
optimizer_utils_value_get_process_manager (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void
optimizer_utils_value_set_process_manager (GValue* value,
                                           gpointer v_object)
{
	OptimizerUtilsProcessManager * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		optimizer_utils_process_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		optimizer_utils_process_manager_unref (old);
	}
}


void
optimizer_utils_value_take_process_manager (GValue* value,
                                            gpointer v_object)
{
	OptimizerUtilsProcessManager * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		optimizer_utils_process_manager_unref (old);
	}
}


static void
optimizer_utils_process_manager_class_init (OptimizerUtilsProcessManagerClass * klass)
{
	optimizer_utils_process_manager_parent_class = g_type_class_peek_parent (klass);
	((OptimizerUtilsProcessManagerClass *) klass)->finalize = optimizer_utils_process_manager_finalize;
	g_type_class_add_private (klass, sizeof (OptimizerUtilsProcessManagerPrivate));
	optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_ADDED_SIGNAL] = g_signal_new ("process-added", OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OPTIMIZER_UTILS_PROCESS, G_TYPE_NONE, 1, OPTIMIZER_UTILS_TYPE_PROCESS);
	optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_PROCESS_REMOVED_SIGNAL] = g_signal_new ("process-removed", OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	optimizer_utils_process_manager_signals[OPTIMIZER_UTILS_PROCESS_MANAGER_UPDATED_SIGNAL] = g_signal_new ("updated", OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
optimizer_utils_process_manager_instance_init (OptimizerUtilsProcessManager * self)
{
	guint64* _tmp0_;
	guint64* _tmp1_;
	self->priv = OPTIMIZER_UTILS_PROCESS_MANAGER_GET_PRIVATE (self);
	self->priv->cpu_last_used = (guint64) 0;
	self->priv->cpu_last_total = (guint64) 0;
	_tmp0_ = g_new0 (guint64, 32);
	self->priv->cpu_last_useds = _tmp0_;
	self->priv->cpu_last_useds_length1 = 32;
	self->priv->_cpu_last_useds_size_ = self->priv->cpu_last_useds_length1;
	_tmp1_ = g_new0 (guint64, 32);
	self->priv->cpu_last_totals = _tmp1_;
	self->priv->cpu_last_totals_length1 = 32;
	self->priv->_cpu_last_totals_size_ = self->priv->cpu_last_totals_length1;
	self->ref_count = 1;
}


static void
optimizer_utils_process_manager_finalize (OptimizerUtilsProcessManager * obj)
{
	OptimizerUtilsProcessManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OPTIMIZER_UTILS_TYPE_PROCESS_MANAGER, OptimizerUtilsProcessManager);
	g_signal_handlers_destroy (self);
	self->priv->_cpu_loads = (g_free (self->priv->_cpu_loads), NULL);
	self->priv->cpu_last_useds = (g_free (self->priv->cpu_last_useds), NULL);
	self->priv->cpu_last_totals = (g_free (self->priv->cpu_last_totals), NULL);
	_g_object_unref0 (self->priv->process_list);
	_g_object_unref0 (self->priv->kernel_process_blacklist);
}


/**
     * The {@code ProcessManager} class is responsible for getting information about
     * running processes
     *
     * @since 1.0.0
     */
GType
optimizer_utils_process_manager_get_type (void)
{
	static volatile gsize optimizer_utils_process_manager_type_id__volatile = 0;
	if (g_once_init_enter (&optimizer_utils_process_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { optimizer_utils_value_process_manager_init, optimizer_utils_value_process_manager_free_value, optimizer_utils_value_process_manager_copy_value, optimizer_utils_value_process_manager_peek_pointer, "p", optimizer_utils_value_process_manager_collect_value, "p", optimizer_utils_value_process_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (OptimizerUtilsProcessManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) optimizer_utils_process_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OptimizerUtilsProcessManager), 0, (GInstanceInitFunc) optimizer_utils_process_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType optimizer_utils_process_manager_type_id;
		optimizer_utils_process_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "OptimizerUtilsProcessManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&optimizer_utils_process_manager_type_id__volatile, optimizer_utils_process_manager_type_id);
	}
	return optimizer_utils_process_manager_type_id__volatile;
}


gpointer
optimizer_utils_process_manager_ref (gpointer instance)
{
	OptimizerUtilsProcessManager * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void
optimizer_utils_process_manager_unref (gpointer instance)
{
	OptimizerUtilsProcessManager * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		OPTIMIZER_UTILS_PROCESS_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



